; Startup code for cc65
;
; Modified from the NES cc65 crt0.s by Groepaz/Hitmen <groepaz@gmx.net>,
; originally based on code by Ullrich von Bassewitz <uz@cc65.org>.

    .export         _exit
    .export         crt0_start
    .export         __STARTUP__ : absolute = 1      ; Mark as startup

    .import         copydata
    .import         vector_reset

    .include        "zeropage.inc"

; ------------------------------------------------------------------------
; reserved memory

.define STACK_SIZE $80

.segment "CSTACK"
cstack: .res STACK_SIZE

; ------------------------------------------------------------------------
; crt0_start should be called from vector_reset routine

.segment        "STARTUP"

crt0_start:
; initialize data
        jsr     copydata
; setup the C stack
        lda     #<(cstack + STACK_SIZE)
        sta     sp
        lda     #>(cstack + STACK_SIZE)
        sta     sp+1            ; Set argument stack ptr
        rts

; _exit should just reset, there is no quit process on NES
_exit:
        jmp     vector_reset

; end of file